#include "ResizeNearestPlugin.hpp"

ResizeNearest::ResizeNearest(float scale) : mScale(scale)
{
    assert(mScale > 0);
};

ResizeNearest::ResizeNearest(const void* data, size_t length)
{
    (void) length;
    
    const char *d = reinterpret_cast<const char*>(data);
    read(d, mScale);
    read(d, mInputDims);
    read(d, mOutputDims);

    assert(d == a + length);

    /**
    mInputDims = Dims3();
    mInputDims.d[0] = read<int>(d);
    mInputDims.d[1] = read<int>(d);
    mInputDims.d[2] = read<int>(d);
    mOutputDims = Dims3();
    mOutputDims.d[0] = read<int>(d);
    mOutputDims.d[1] = read<int>(d);
    mOutputDims.d[2] = read<int>(d);
    ASSERT(d == a + length);
    **/
};

ResizeNearest::~ResizeNearest()
{

};

int32_t ResizeNearest::getNbOutputs() const
{
    return 1;
};

dwBlobSize ResizeNearest::getOutputDimensions(int index, const dwBlobSize* inputs, int nbInputDims)
{
    (void) index;
    (void) nbInputDims;
    dwBlobSize const& input = inputs[0];
    dwBlobSize output;
    output.batchsize =  input.batchsize;

    return output;
};

bool ResizeNearest::supportsFormat(dwPrecision precision, dwDNNPluginLayout layout) const
{
    return (precision == DW_PRECISION_FP32 || precision == DW_PRECISION_FP16) && layout == DW_DNN_PLUGIN_LAYOUT_NCHW;
};

int ResizeNearest::initialize()
{
    CHECK_CUDA_ERROR(cudnnCreate(&m_cudnn));// initialize cudnn and cublas
    CHECK_CUDA_ERROR(cublasCreate(&m_cublas));
    CHECK_CUDA_ERROR(cudnnCreateTensorDescriptor(&m_srcDescriptor));// create cudnn tensor descriptors we need for bias addition
    CHECK_CUDA_ERROR(cudnnCreateTensorDescriptor(&m_dstDescriptor));
    return 0;
};

void ResizeNearest::terminate()
{

};

size_t ResizeNearest::getWorkspaceSize(int) const 
{
    return 0;
};
/**
int ResizeNearest::enqueue(int batch_size, const void* const* inputs, void** outputs, void* workspace, cudaStream_t stream)
{
    
    int nchan = mOutputDims.d[0];
    float scale = mScale;
    int2 osize = {mOutputDims.d[2], mOutputDims.d[1]};
    int istride = mInputDims.d[2];
    int ostride = mOutputDims.d[2];
    int ibatchstride = mInputDims.d[1] * istride;
    int obatchstride = mOutputDims.d[1] * ostride;
    dim3 block(32, 16);
    dim3 grid((osize.x - 1) / block.x + 1, (osize.y - 1) / block.y + 1, std::min(batch_size * nchan, 65535));

    resizeNearest(grid, block, stream, batch_size * nchan, scale, osize, static_cast<float const*>(inputs[0]), istride,
        ibatchstride, static_cast<float*>(outputs[0]), ostride, obatchstride);

    return cudaGetLastError() != cudaSuccess;
};
**/